'use strict';

function objMPContext() {

  this.BuildMenu = function() {
    var cm = gContextMenu;
    var url = '';
    var Comment = '';
    var refe = MPIntComm.getRefe();
    if (cm.onLink) {
      url = cm.linkURL;
      Comment = cm.linkText();
    } else if (cm.onImage) {
      url = cm.target.currentURI.spec;
      Comment = cm.target.alt;
      if (!Comment)
        Comment = url;
    };

    var elm, IsElm, IsMD;
    if (MPIntComm.IsMD) {
      IsMD = false;
      elm = document.getElementById('md-download-url');
      IsElm = url != '';
      elm.hidden = !IsElm;
      if (IsElm) {
        IsMD = true;
        elm.setAttribute('url', url);
        elm.setAttribute('refe', refe);
        elm.setAttribute('Comment', Comment);
      };
      elm = document.getElementById('md-sel');
      IsElm = MPIntComm.IsSel();
      elm.hidden = !IsElm;
      if (IsElm) {
        IsMD = true;
        elm.setAttribute('refe', refe);
      };
      elm = document.getElementById('md-all');
      IsElm = MPIntComm.IsLinks();
      elm.hidden = !IsElm;
      if (IsElm) {
        IsMD = true;
        elm.setAttribute('refe', refe);
      };
      elm = document.getElementById('mpint-md-menu');
      elm.hidden = !IsMD;
    };
    if (MPIntComm.IsDE) {
      elm = document.getElementById('de-download-url');
      IsElm = url != '';
      elm.hidden = !IsElm;
      if (IsElm) {
        elm.setAttribute('url', url);
        elm.setAttribute('refe', refe);
      };
    };
    if (MPIntComm.IsOE) {
      elm = document.getElementById('oe-save-url');
      IsElm = url != '';
      elm.hidden = !IsElm;
      if (IsElm) {
        elm.setAttribute('url', url);
        elm.setAttribute('refe', refe);
      };
      elm = document.getElementById('oe-save-cururl');
      elm.setAttribute('url', refe);
    };
    if (MPIntComm.IsIQ) {
      elm = document.getElementById('iq-save-url');
      IsElm = (url != '') && (/^(http|https):\/\//.test(url));
      elm.hidden = !IsElm;
      if (IsElm) {
        elm.setAttribute('url', url);
        elm.setAttribute('Comment', Comment);
      };
      elm = document.getElementById('iq-save-cururl');
      IsElm = (refe != '') && (/^(http|https):\/\//.test(refe));
      MPIntComm.SetEnabled(elm, IsElm);
      if (IsElm) {
        elm.setAttribute('url', refe);
        elm.setAttribute('Comment', '');
      };
    };
  };

  this.MPDownload = function(e) {
    var t = e.target;
    MPIntComm.DownloadMDURL(t.getAttribute('url'), t.getAttribute('refe'),
     t.getAttribute('Comment'));
  };

  this.MPDownloadSel = function(e) {
    var t = e.target;
    MPIntComm.DownloadMDSel(t.getAttribute('refe'));
  };

  this.MPDownloadAll = function(e) {
    var t = e.target;
    MPIntComm.DownloadMDAll(t.getAttribute('refe'));
  };

  this.DEDownload = function(e) {
    var t = e.target;
    MPIntComm.DownloadDEURL(t.getAttribute('url'), t.getAttribute('refe'));
  };

  this.OEDownload = function(e) {
    var t = e.target;
    MPIntComm.DownloadOEURL(t.getAttribute('url'), t.getAttribute('refe'));
  };

  this.IQDownload = function(e) {
    var t = e.target;
    MPIntComm.DownloadIQURL(t.getAttribute('url'), t.getAttribute('Comment'));
  };

  this.OEToolbar = function() {
    if (MPIntComm.IsOE) {
      var url = MPIntComm.getRefe();
      MPIntComm.DownloadOEURL(String(url));
    } else
      alert('Offline Explorer is not detected. Please visit http://www.metaproducts.com to install it.');
  };

  this.IQToolbar = function() {
    if (MPIntComm.IsIQ) {
      var url = MPIntComm.getRefe();
      var IsElm = (url) && (/^(http|https):\/\//.test(url));
      if (IsElm)
        MPIntComm.DownloadIQURL(String(url));
      else
        alert('MetaProducts Inquiry can save only web pages from Internet');
    } else
      alert('MetaProducts Inquiry is not detected. Please visit http://www.metaproducts.com to install it.');
  };

  function IsAnchor(node) {
    return (node instanceof HTMLAnchorElement)
     || (node instanceof HTMLAreaElement);
  };

  function FindAnchor(node) {
    while(node) {
      if (IsAnchor(node))
        return node
      else
        node = node.parentNode;
    };
  };

  this.Click = function(ev) {
    try {
      if (ev.shiftKey && !(ev.ctrlKey || ev.altKey)) {
        Application.storage.set('MPIntShiftLastClick',
         MPIntComm.getPref('DontIntercept', false));
      } else {
        Application.storage.set('MPIntShiftLastClick', false);
        var sel = document.commandDispatcher.focusedWindow.getSelection();
        var linknode = FindAnchor(sel.anchorNode);
        if (!linknode)
          linknode = FindAnchor(document.commandDispatcher.focusedElement);
        if (IsAnchor(linknode)) {
          var InterceptKey = MPIntComm.getPref('InterceptKey', 2);
          if ((InterceptKey < 0) || (InterceptKey > 3))
            InterceptKey = 2;
          var KeyPressed = false;
          switch (InterceptKey) {
            case 0:
              KeyPressed = ev.ctrlKey && !(ev.altKey || ev.shiftKey);
              break;
            case 1:
              KeyPressed = ev.altKey && !(ev.ctrlKey || ev.shiftKey);
              break;
            case 2:
              KeyPressed = ev.ctrlKey && ev.altKey && !ev.shiftKey;
              break;
            case 3:
              KeyPressed = ev.shiftKey && ev.ctrlKey && !ev.altKey;
              break;
          };
          if (KeyPressed) {
            ev.preventDefault();
            ev.stopPropagation();
            var url = linknode.href;
            var refe = MPIntComm.getRefe();
            if (MPIntComm.getPref('DefDL', 'MD') == 'MD')
              MPIntComm.DownloadMDURL(url, refe);
            else
              MPIntComm.DownloadDEURL(url, refe);
          };
        };
      };
    } catch(ex) {};
  };

  try {
    document.getElementById('mpint-md-menu').hidden = !MPIntComm.IsMD;
    document.getElementById('de-download-url').hidden = !MPIntComm.IsDE;
    document.getElementById('mpint-oe-menu').hidden = !MPIntComm.IsOE;
    document.getElementById('mpint-iq-menu').hidden = !MPIntComm.IsIQ;
    if (MPIntComm.IsMD || MPIntComm.IsDE || MPIntComm.IsOE || MPIntComm.IsIQ) {
      document.getElementById('contentAreaContextMenu')
       .addEventListener('popupshowing', this.BuildMenu, false);
      window.addEventListener('click', this.Click, true);
    };
  } catch(ex) {};
};

window.addEventListener('load',
  function() {
    MPIntComm.init();
    this.MPContext = new objMPContext();
  },
  false);
